<script setup lang="ts">
import { useAuthStore } from '@/stores/auth'
import { useMemberStore } from '@/stores/member'
import { useReceiptStore } from '@/stores/receipt'
import { ref } from 'vue'

const memberStore = useMemberStore()
const receiptStore = useReceiptStore()
const userStore = useAuthStore()
const currentUser = ref(userStore.currentUser)
let q = 1

function incQ() {
  q++
}

function generateRandomNumber(): string {
  const randomNumber = Math.floor(10000000 + Math.random() * 90000000).toString()
  return randomNumber
}
</script>

<template>
  <v-dialog v-model="receiptStore.receiptDialog" persistent width="500" class="font">
    <v-card class="bill">
      <v-card-title class="head" style="text-align: center"> {{ 'Queue : ' + q }} </v-card-title>
      <p style="font-size: 25px; text-align: center">D-Coffee</p>
      <p style="text-align: center">{{ 'TAXID : ' + generateRandomNumber() }}</p>
      <p style="text-align: center">Burapha University Bangsean</p>
      <p style="text-align: center">{{ receiptStore.receipt.createdDate }}</p>
      <p style="text-align: center">Employee : {{ currentUser ? currentUser.fullName : '' }}</p>
      <p style="margin-left: 2px">---------------------------------------------------------</p>
      <v-sheet min-width="300" max-width="600" height="400" class="overflow-auto">
        <v-table class="font">
          <thead>
            <tr>
              <th>Name</th>
              <th>Price</th>
              <th>Sweet-Level</th>
              <th>Unit</th>
              <th>Total</th>
              <th></th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="item of receiptStore.receiptItems" :key="item.id">
              <td>{{ item.name }}</td>
              <td>{{ item.price }}</td>
              <td>{{ item.sweetLevel + '%' }}</td>
              <td>{{ item.unit }}</td>
              <td>{{ item.price * item.unit }}</td>
            </tr>
          </tbody>
        </v-table>
      </v-sheet>
      <p style="margin-left: 2px">---------------------------------------------------------</p>
      <v-container class="font">
        <v-row no-gutters>
          <v-col cols="6" class="mb-2 text-end">Member :</v-col>
          <v-col cols="6" class="mb-2 text-end">{{
            memberStore.currentMember ? memberStore.currentMember?.tel : '-'
          }}</v-col>
          <v-col cols="6" class="mb-2 text-end">Total :</v-col>
          <v-col cols="6" class="mb-2 text-end">{{ receiptStore.receipt?.total + ' ฿' }}</v-col>
          <v-col cols="6" class="mb-2 text-end">Member Discount :</v-col>
          <v-col cols="6" class="mb-2 text-end">{{
            receiptStore.receipt?.memberDiscount + ' ฿'
          }}</v-col>
          <v-col cols="6" class="mb-2 text-end">Total Net :</v-col>
          <v-col cols="6" class="mb-2 text-end">{{ receiptStore.receipt?.totalNet + ' ฿' }}</v-col>
          <v-col cols="6" class="mb-2 text-end">Payment :</v-col>
          <v-col cols="6" class="mb-2 text-end">{{ receiptStore.receipt.paymentType }}</v-col>
          <v-col cols="6" class="mb-2 text-end">Cash :</v-col>
          <v-col cols="6" class="mb-2 text-end">{{
            receiptStore.receipt.receivedAmount + ' ฿'
          }}</v-col>
          <v-col cols="6" class="mb-2 text-end">Change :</v-col>
          <v-col cols="6" class="mb-2 text-end">{{ receiptStore.receipt?.change + ' ฿' }}</v-col>
        </v-row>
      </v-container>
      <br />
      <p style="text-align: center">Have a nice day ;)</p>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="green-darken-1" variant="text" @click="receiptStore.receiptDialog = false">
          Close
        </v-btn>
        <v-btn
          v-model="q"
          color="green-darken-1"
          variant="text"
          @click="
            () => {
              incQ()
              receiptStore.receiptDialog = false
              receiptStore.clear()
            }
          "
        >
          Save
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<style scoped>
.font {
  font-family: 'Kanit';
}

.head {
  margin-top: 2%;
  font-family: 'Kanit';
  font-size: 25px;
}

.bill {
  width: 430px;
  height: 800px;
}
</style>
